#ifndef EFL_UI_SCROLLABLE_EO_HH
#define EFL_UI_SCROLLABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_scrollable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Scrollable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace ui { 
struct Scrollable {
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_SCROLLABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Scrollable() const;
   operator ::efl::ui::Scrollable&();
   operator ::efl::ui::Scrollable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Scrollable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Scrollable const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Scrollable : ::efl::eo::concrete
{
   explicit Scrollable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Scrollable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Scrollable(Scrollable const& other) = default;
   Scrollable(Scrollable&& other) = default;
   Scrollable& operator=(Scrollable const& other) = default;
   Scrollable& operator=(Scrollable&& other) = default;
   Scrollable()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Scrollable( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Scrollable(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_SCROLLABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct scroll_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL; }
      typedef void parameter_type;
   } const scroll_event;
   static struct scroll_anim_start_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_ANIM_START; }
      typedef void parameter_type;
   } const scroll_anim_start_event;
   static struct scroll_anim_stop_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_ANIM_STOP; }
      typedef void parameter_type;
   } const scroll_anim_stop_event;
   static struct scroll_drag_start_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_DRAG_START; }
      typedef void parameter_type;
   } const scroll_drag_start_event;
   static struct scroll_drag_stop_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_DRAG_STOP; }
      typedef void parameter_type;
   } const scroll_drag_stop_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Scrollable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Scrollable const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Scrollable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Scrollable>::value, "");
} } 
#include "efl_ui_scrollable.eo.impl.hh"
#endif
